"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fileTypeExts = {
    pdf: ['pdf'],
    image: ['jpg', 'jpeg', 'png'],
    pdfImage: ['pdf', 'jpg', 'jpeg', 'png'],
};
var fileTypeAlerts = {
    pdf: 'Please choose a pdf document',
    image: 'Please choose an image file',
    pdfImage: 'Please choose a pdf document or image file',
};
function checkFile(inputFiles, value, maxKb, fileType) {
    if (window.FileReader &&
        inputFiles &&
        inputFiles[0] &&
        inputFiles[0].size > (maxKb || 500) * 1000) {
        alert("The max file size is " + (maxKb || 500) / 1000 + "MB, please try again.");
        return false;
    }
    var ext = value
        .split('.')
        .pop()
        .toLowerCase();
    if (fileTypeExts[fileType] && !fileTypeExts[fileType].includes(ext)) {
        alert(fileTypeAlerts[fileType]);
        return false;
    }
    return true;
}
exports.default = checkFile;
